//+------------------------------------------------------------------+
//|                                                    BBQ_EA_V1.0.0 |
//|                                                        H1 eurusd |
//|                                   created by Monty666 2012-07-16 |
//+------------------------------------------------------------------+
//
// Version 1.0.0 BBQ_EA - 2012-07-17
// 
#property copyright "Copyright  2012 Monty666"
#property link      "BBQ_EA"
//
//---- input parameters
extern double StopLoss     = 90;
extern double TakeProfit   = 50;
extern double Lots         = 0.1;
extern int SlipPage        = 0;
extern double MaxSpread    = 2.0;
extern int TrailingStop    = 7;
extern int TrailingStep    = 10;
extern int BreakEven       = 4;
extern int movestopto      = 2;
extern string Checkbar = "1=safer 0=standard";
extern int    CheckNewBar  = 0;
extern bool UseMM          = TRUE;
extern double PercentageMM = 20.0;
extern int    TimeControl  = 0;
extern string TimeZone = "Adjust TimeZone if required";
extern int    ServerTimeZone = 1;
extern string TradingTimes   = "Time & Newsfilter";
extern int    HourStartGMT   = 8;
extern int    HourStopGMT    = 21;
extern bool AvoidNews        = TRUE;
extern int MinimumImpact     = 3;
extern int MinsBeforeNews    = 60;
extern int MinsAfterNews     = 30;
extern string DontTradeFriday = "Dont Trade After FridayFinalHourGMT";
extern bool   UseFridayFinalTradeTime = TRUE;
extern int    FridayFinalHourGMT = 11;
extern string  SignalSettings    = "Indicators"; 
extern int MA_Period = 100;
extern int Slippage_MA = 80;
extern int Williams_Period = 19;
extern int Level_High = 15;
extern int Level_Low = 85;
extern int ATR_Period = 18;
extern int Level_ATR_Stop = 15;
extern int CCI_Period = 12;
extern int Level_CCI_High = 50;
extern int Level_CCI_Low = -70;
extern double RSIParamBuy = 70;
extern double RSIParamSell = 30;
extern int MagicNumber           = 2094449;
extern string TradeComment       = "BBQ EA";

double point;
int digits,i,D;
int BarCount;
int Current;
int gi_240 = 0;
int gi_244 = 0;
int gi_224 = 0;
int gi_228 = 6;
int gi_328;
int g_error_332;
double g_price_336;
double g_price_344;
double g_price_352;
double gd_360;
double gd_368;
double g_iclose_376;
double g_iatr_384;
double g_iwpr_392;
double g_icci_400;
double g_ima_408;
int g_datetime_420;

//+------------------------------------------------------------------+
//| Time Filter                                                      |
//+------------------------------------------------------------------+
bool TradeSession() {
   int Hour_Start_Trade;
   int Hour_Stop_Trade;
   Hour_Start_Trade = HourStartGMT + ServerTimeZone;
   Hour_Stop_Trade = HourStopGMT + ServerTimeZone;
   if (Hour_Start_Trade < 0)Hour_Start_Trade = Hour_Start_Trade + 24;
   if (Hour_Start_Trade >= 24)Hour_Start_Trade = Hour_Start_Trade - 24;
   if (Hour_Stop_Trade > 24)Hour_Stop_Trade = Hour_Stop_Trade - 24;
   if (Hour_Stop_Trade <= 0)Hour_Stop_Trade = Hour_Stop_Trade + 24;
   if ((UseFridayFinalTradeTime && (Hour()>=FridayFinalHourGMT + ServerTimeZone) && DayOfWeek()==5)||DayOfWeek()==0)return (FALSE); // Friday Control
   if((TimeControl(Hour_Start_Trade,Hour_Stop_Trade)!=1 && TimeControl==1 && Hour_Start_Trade<Hour_Stop_Trade)
        || (TimeControl(Hour_Stop_Trade,Hour_Start_Trade)!=0 && TimeControl==1 && Hour_Start_Trade>Hour_Stop_Trade)
          ||TimeControl==0)return (TRUE); // "Trading Time";
    return (FALSE); // "Non-Trading Time";
}

int TimeControl(int StartHour, int EndHour)
{
   if (Hour()>=StartHour &&  Hour()< EndHour)
      { 
      return(0);
      }
return(1);
}
//+------------------------------------------------------------------+
//| bar ckeck                                                        |
//+------------------------------------------------------------------+
bool isNewBar()
{
   static datetime NewTime = 0;
   bool NewBar = false;
   if (NewTime != Time[0])
   {
      NewTime = Time[0];
      NewBar = true;
   }
   return (NewBar);
}
//+------------------------------------------------------------------+
//| Lots Sizes and Automatic Money Management                        |
//+------------------------------------------------------------------+
 double GetLots()
 { 
   if (UseMM)
    {
      double a, maxLot, minLot;
      a = (PercentageMM * AccountFreeMargin() / 100000);
      double LotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
      maxLot  = MarketInfo(Symbol(), MODE_MAXLOT );
      minLot  = MarketInfo(Symbol(), MODE_MINLOT );   
      a =  MathFloor(a / LotStep) * LotStep;
      if (a > maxLot) return(maxLot);
      else if (a < minLot) return(minLot);
      else return(a);
    }    
   else return(Lots);
 }
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//Calculate for 4 or 5 digits broker
    if(Digits==5||Digits==3){ D=10;}
    else{D=1;}
    if(Digits<4)
   {
      point=0.01;
      digits=2;
      gi_328 = 10;
   }
   else
   {
      point=0.0001;
      digits=4;
      gi_328 = 1;
   }
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| MaxSpread                                                        |
//+------------------------------------------------------------------+
bool Mspread() {
   double Spread = Ask-Bid;
   if(Spread <= MaxSpread * point)return (TRUE);
    return (FALSE); // "Non-Trading Time";
}  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  int cnt, ticket, total;
  double SL,TP; 
  total=OrdersTotal();
  int OpenedOrders=0;
//+------------------------------------------------------------------+
//| newsfilter                                                       |
//+------------------------------------------------------------------+
	bool ContinueTrading=true;
   if(AvoidNews && !IsTesting())
   {
   static int PrevMinute=-1;  
   
   int MinSinceNews=iCustom(NULL,0,"FFCal",true,true,false,true,true,1,0);
   int MinToNews=iCustom(NULL,0,"FFCal",true,true,false,true,true,1,1);
         
   int ImpactSinceNews=iCustom(NULL,0,"FFCal",true,true,false,true,true,2,0);
   int ImpactToNews=iCustom(NULL,0,"FFCal",true,true,false,true,true,2,1);

   if(Minute()!=PrevMinute)
   {
   PrevMinute=Minute();
   if((MinToNews<=MinsBeforeNews &&  ImpactToNews>=MinimumImpact) || (MinSinceNews<=MinsAfterNews && ImpactSinceNews>=MinimumImpact))ContinueTrading=false;
   }
	}
//+------------------------------------------------------------------+
//| trailing                                                         |
//+------------------------------------------------------------------+
  if(TrailingStop>0)MoveTrailingStop();
  if(BreakEven>0)MoveBreakEven();

  for(cnt=0; cnt<OrdersTotal(); cnt++)
  {
  if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
  { 
  if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber) 
  {
  if(OrderStopLoss()==0 && (StopLoss>0)) 
  if(OrderType()==OP_BUY) 
  {
  SL = OrderStopLoss();
  double open=OrderOpenPrice();
  if (StopLoss>0) {SL =(OrderOpenPrice() - (StopLoss*point));}
  if(TakeProfit!=0){TP=open+TakeProfit*point;}

  OrderModify(OrderTicket(),OrderOpenPrice(),SL,TP,Green);
  return(0);
  }
  if(OrderStopLoss()==0 && (StopLoss>0)) 
  if(OrderType()==OP_SELL) 
  {
  SL = OrderStopLoss();
  double open2=OrderOpenPrice();
  if (StopLoss>0) {SL =(OrderOpenPrice() + (StopLoss*point));}
  if(TakeProfit!=0){TP=open2-TakeProfit*point;}

  OrderModify(OrderTicket(),OrderOpenPrice(),SL,TP,Green);
  return(0);
}
}
}
}
//+------------------------------------------------------------------+
//| signals                                                          |
//+------------------------------------------------------------------+  
int sign1, sign2;
//+------------------------------------------------------------------+
	double ld_40 = iRSI(NULL, PERIOD_H1, RSIParamBuy, PRICE_CLOSE, 0);
	double ld_48 = iRSI(NULL, PERIOD_H1, RSIParamSell, PRICE_CLOSE, 0);
	if (ld_40 > 50.0) sign1=1;
	if (ld_48 < 50.0) sign1=-1;

	g_iclose_376 = iClose(NULL, 0, 1);
	g_ima_408 = iMA(NULL, 0, MA_Period, 0, MODE_SMMA, PRICE_CLOSE, 1);
	g_iwpr_392 = iWPR(NULL, 0, Williams_Period, 1);
	g_iatr_384 = iATR(NULL, 0, ATR_Period, 1);
	g_icci_400 = iCCI(NULL, 0, CCI_Period, PRICE_TYPICAL, 1);
	g_datetime_420 = iTime(Symbol(), 0, 0);
// buy	
	if (g_iclose_376 > g_ima_408 + Slippage_MA * gi_328 * point && g_iwpr_392 < (-1 * Level_Low) && g_icci_400 < Level_CCI_Low && g_iatr_384 > Level_ATR_Stop * gi_328 * point) sign2=1;	
// sell
	if (g_iclose_376 < g_ima_408 - Slippage_MA * gi_328 * point && g_iwpr_392 > (-1 * Level_High) && g_icci_400 > Level_CCI_High && g_iatr_384 > Level_ATR_Stop * gi_328 * point) sign2=-1;
	
//+------------------------------------------------------------------+
//| count orders                                                     |
//+------------------------------------------------------------------+

if (Month()==12) return (0);  // no trades in december

   for(i=0;i<total;i++)
   {
   if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      if(OrderType()<=OP_SELL&&OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
      {
       OpenedOrders++;
       }
       }
//+------------------------------------------------------------------+
//| open buy                                                         |
//+------------------------------------------------------------------+
		if (CheckNewBar==1 && sign1==1 && sign2==1 && isNewBar()) {
		if(OpenedOrders==0 && TradeSession() && ContinueTrading && Mspread()) ticket=OrderSend(Symbol(),OP_BUY,GetLots(),Ask,SlipPage,0,0,TradeComment,MagicNumber,0,Green);
      }

      if (CheckNewBar==0 && sign1==1 && sign2==1) {
      if(OpenedOrders==0 && TradeSession() && ContinueTrading && Mspread()) ticket=OrderSend(Symbol(),OP_BUY,GetLots(),Ask,SlipPage,0,0,TradeComment,MagicNumber,0,Green);
      }

//+------------------------------------------------------------------+
//| open sell                                                        |
//+------------------------------------------------------------------+
      if (CheckNewBar==1 && sign1==-1 && sign2==-1 && isNewBar()) {
      if(OpenedOrders==0 && TradeSession() && ContinueTrading && Mspread()) ticket=OrderSend(Symbol(),OP_SELL,GetLots(),Bid,SlipPage,0,0,TradeComment,MagicNumber,0,Red);
      }

      if (CheckNewBar==0 && sign1==-1 && sign2==-1) {
      if(OpenedOrders==0 && TradeSession() && ContinueTrading && Mspread()) ticket=OrderSend(Symbol(),OP_SELL,GetLots(),Bid,SlipPage,0,0,TradeComment,MagicNumber,0,Red);
      }

//+------------------------------------------------------------------+
//| open orders end                                                  |
//+------------------------------------------------------------------+
   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| trailing functions                                               |
//+------------------------------------------------------------------+
void MoveTrailingStop()
{
   int cnt,total=OrdersTotal();
for(cnt=0; cnt<OrdersTotal(); cnt++)
{
if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
{ 
      if(OrderType()<=OP_SELL&&OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
      {
         if(OrderType()==OP_BUY)
         {
            if(TrailingStop>0&&NormalizeDouble(Ask-TrailingStep*point,digits)>NormalizeDouble(OrderOpenPrice()+TrailingStop*point,digits))  
            {                 
               if((NormalizeDouble(OrderStopLoss(),digits)<NormalizeDouble(Bid-TrailingStop*point,digits))||(OrderStopLoss()==0))
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid-TrailingStop*point,digits),OrderTakeProfit(),0,Blue);
                 
               }
            }
         }
         else 
         {
            if(TrailingStop>0&&NormalizeDouble(Bid+TrailingStep*point,digits)<NormalizeDouble(OrderOpenPrice()-TrailingStop*point,digits))  
            {                 
               if((NormalizeDouble(OrderStopLoss(),digits)>(NormalizeDouble(Ask+TrailingStop*point,digits)))||(OrderStopLoss()==0))
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask+TrailingStop*point,digits),OrderTakeProfit(),0,Red);
                 
               }
            }
         }
      }
   }
}
return(0);
}
//+------------------------------------------------------------------+
//| breakeven                                                        |
//+------------------------------------------------------------------+
void MoveBreakEven()
{
   int cnt,total=OrdersTotal();
for(cnt=0; cnt<OrdersTotal(); cnt++)
{
if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
{ 
      if(OrderType()<=OP_SELL&&OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
      {
         if(OrderType()==OP_BUY)
         {
            if(BreakEven>0)
            {
               if(NormalizeDouble((Bid-OrderOpenPrice()),digits)>BreakEven*point)
               {
                  if(NormalizeDouble((OrderStopLoss()-OrderOpenPrice()),digits)<0)
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()+movestopto*point,digits),OrderTakeProfit(),0,Blue);
                     
                  }
               }
            }
         }
         else
         {
            if(BreakEven>0)
            {
               if(NormalizeDouble((OrderOpenPrice()-Ask),digits)>BreakEven*point)
               {
                  if(NormalizeDouble((OrderOpenPrice()-OrderStopLoss()),digits)<0)
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()-movestopto*point,digits),OrderTakeProfit(),0,Red);
                    
                  }
               }
            }
         }
      }
   }
   
   }

   return(0);
}
//+------------------------------------------------------------------+
//| end                                                              |
//+------------------------------------------------------------------+